/********************************************************************/
/* Copyright (c) 2019 System fugen G.K. and Yuzi Mizuno          */
/* All rights reserved.                                             */
/********************************************************************/
/********************************************************************/
/**
 * @file Parabola.h
 * @brief MGParabolaTool クラスのインターフェイス
 */
#if !defined(AFX_CURVEPARABOLA_H__5F8B4405_B4AA_441A_A2B9_CCB9C555ECAC__INCLUDED_)
#define AFX_CURVEPARABOLA_H__5F8B4405_B4AA_441A_A2B9_CCB9C555ECAC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Common/LocateState.h"
#include "mg/Curve.h"

/// @class MGParabolaTool Parabola.h CurveCmd/Parabola.h
///
/// 頂点と方向、終点を与えて放物線を生成する
class MGParabolaTool : public MGLocateState{
public:
	explicit MGParabolaTool(fugenDoc* pDoc);

	virtual MGCommandBase* initial_clone(fugenDoc* pDoc)const;
	virtual bool initiate_tool();
	virtual bool terminate_tool(bool cancel = false);

	virtual bool OnKeyDown(fugenView* pView, UINT nChar, UINT nRepCnt, UINT nFlags);
	virtual bool OnLocated(const MGLocateInfo& info);

	virtual void do_make_temporary_display(mgSysGL& sgl,fugenView* pSView);

private:
	bool calculate();
	void prompt_message() const;
	
	std::unique_ptr<MGCurve> m_parabola; ///< 一時描画用オブジェクト
	UINT m_nIDS; ///< エラーメッセージ
	bool m_bHalf; ///< 放物線は片側だけ生成するかどうか
};

#endif // !defined(AFX_CURVEPARABOLA_H__5F8B4405_B4AA_441A_A2B9_CCB9C555ECAC__INCLUDED_)
